from cdo import *
import sets


def settaxis(dataname, varname, f, d):
    cdo=Cdo()
    """test if the calendar is well written and return a another file 
    with the rigth time axis if needed
    - dataname: the name the experience
    - f: the file to be checked
    - d: the startdate of the file
    """
    #calendar and frequency definition in ensemble case    
    timeinfo = { "EnsCmccSeas":("360days","1day"),
                 "EnsMetfrSeas":("360days","1day"),
                 "EnsEcmwfSeas":("360days","1day"),
                 "EnsUkmoSeas":("360days","1day"),
                 "EnsIfmSeas":("360days","1day") } 
    taxis = (cdo.showtimestamp(input=f)[0]).split()
    if (len(sets.Set(taxis)) == 1):  # and (len(sets.Set(taxis[0:-1]-taxis[1:])) != 1):
        print "Warning: the calendar of the file is wrong"
        try:
            calendar, freq = timeinfo.get(dataname)
        except:
            print "no default value of calendar and frequency has been set for the %s experiment" % dataname
            sys.exit(0)
        print "It has been rewriten with a %s calendar and a %s frequency" % (calendar, freq)
        fileout="taxis_"+(f.split("/"))[-1]
        f=cdo.setcalendar(calendar, input=f)
        cdo.settaxis(d, "12:00", freq,  input=f, output=fileout,options="-r -f nc")
        #chtaxis_360d(f, varname, d)
        print fileout
    return fileout
